loci.formats.in

## Class LIFReader

- java.lang.Object
- - loci.formats.FormatHandler
  - - loci.formats.FormatReader
    - - loci.formats.in.LIFReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, ICompressedTileReader, IFormatHandler, IFormatReader, IMetadataConfigurable, IPyramidHandler

      public class LIFReader
      extends FormatReader

  LIFReader is the file format reader for Leica LIF files.
  Author:
    Melissa Linkert melissa at glencoesoftware.com

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) class` | `LIFReader.MemoryBlock`
    `(package private) class` | `LIFReader.ROI`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private double[]` | `acquiredDate`
    `private java.util.List[]` | `activeDetector`
    `private boolean` | `alternateCenter`
    `private static com.google.common.collect.ImmutableMap<java.lang.String,java.lang.Integer>` | `CHANNEL_PRIORITIES`
    `private java.lang.String[][]` | `channelNames`
    `private java.lang.String[]` | `corrections`
    `private java.util.List[]` | `cutIns`
    `private java.util.List[]` | `cutOuts`
    `private java.lang.String[]` | `descriptions`
    `private java.util.HashMap[]` | `detectorIndexes`
    `private java.util.List[]` | `detectorModels`
    `private java.lang.Double[][]` | `detectorOffsets`
    `private static java.lang.String` | `ENCODING` The encoding used in this file.
    `private long` | `endPointer`
    `private java.lang.Double[][]` | `expTimes`
    `private java.lang.Double[][]` | `exWaves`
    `private java.util.List<ome.units.quantity.Length>` | `fieldPosX`
    `private java.util.List<ome.units.quantity.Length>` | `fieldPosY`
    `private java.util.List[]` | `filterModels`
    `private boolean[]` | `flipX`
    `private boolean[]` | `flipY`
    `private java.lang.Double[][]` | `gains`
    `private java.lang.String[]` | `imageNames`
    `private LIFReader.ROI[][]` | `imageROIs`
    `private java.lang.String[]` | `immersions`
    `private java.util.List[]` | `laserActive`
    `private java.util.List[]` | `laserFrap`
    `private java.util.List[]` | `laserIntensity`
    `private java.util.List[]` | `laserWavelength`
    `private int` | `lastChannel`
    `private java.lang.Double[]` | `lensNA`
    `static byte` | `LIF_MAGIC_BYTE`
    `static byte` | `LIF_MEMORY_BYTE`
    `private static java.lang.String` | `LOGO_FILE`
    `private java.util.List<java.lang.String>` | `lutNames`
    `private java.lang.Double[]` | `magnification`
    `private java.util.List<LIFReader.MemoryBlock>` | `memoryBlocks` Memory blocks including offsets and ID
    `private static long` | `METER_MULTIPLY`
    `private java.lang.String[]` | `microscopeModels`
    `private java.lang.String[]` | `objectiveModels`
    `static boolean` | `OLD_PHYSICAL_SIZE_DEFAULT`
    `static java.lang.String` | `OLD_PHYSICAL_SIZE_KEY`
    `private java.util.List<java.lang.Double>` | `physicalSizeXs`
    `private java.util.List<java.lang.Double>` | `physicalSizeYs`
    `private java.lang.Double[]` | `pinholes`
    `private ome.units.quantity.Length[]` | `posX`
    `private ome.units.quantity.Length[]` | `posY`
    `private ome.units.quantity.Length[]` | `posZ`
    `private int[][]` | `realChannel`
    `private java.lang.Double[]` | `refractiveIndex`
    `private java.lang.String[]` | `serialNumber`
    `private static java.lang.String` | `STYLESHEET_FILE`
    `private boolean[]` | `swapXY`
    `private long[]` | `tileBytesInc`
    `private int[]` | `tileCount`
    `private java.lang.Double[][]` | `timestamps`
    `private java.lang.Double[]` | `tSteps`
    `private java.lang.Double[]` | `zooms`
    `private java.lang.Double[]` | `zSteps`

    - ### Fields inherited from class loci.formats.FormatReader

      `core, coreIndex, datasetDescription, domains, fillColor, filterMetadata, flattenedResolutions, group, hasCompanionFiles, in, indexedAsRGB, metadata, metadataStore, normalizeData, resolution, saveOriginalMetadata, series, suffixNecessary, suffixSufficient, THUMBNAIL_DIMENSION`

    - ### Fields inherited from class loci.formats.FormatHandler

      `COMPRESSION_SUFFIXES, currentId, format, LOGGER, metadataOptions, suffixes`

    - ### Fields inherited from interface loci.formats.IFormatReader

      `CAN_GROUP, CANNOT_GROUP, MUST_GROUP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LIFReader()` Constructs a new Leica LIF reader.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addUserCommentMeta(org.w3c.dom.Element imageNode, int image)`
    `private ome.units.quantity.Length` | `checkFlip(boolean flip, ome.units.quantity.Length pos)`
    `void` | `close(boolean fileOnly)` Closes the currently open file.
    `private static com.google.common.collect.ImmutableMap<java.lang.String,java.lang.Integer>` | `createChannelPriorities()`
    `short[][]` | `get16BitLookupTable()` Gets the 16-bit color lookup table associated with the most recently opened image.
    `byte[][]` | `get8BitLookupTable()` Gets the 8-bit color lookup table associated with the most recently opened image.
    `protected java.util.ArrayList<java.lang.String>` | `getAvailableOptions()` Returns the list of available metadata options.
    `private ome.xml.model.primitives.Color` | `getChannelColor(int colorCode)`
    `private org.w3c.dom.NodeList` | `getChannelDescriptionNodes(org.w3c.dom.Element root)`
    `private int` | `getChannelIndex(org.w3c.dom.Element filterSetting)`
    `private org.w3c.dom.NodeList` | `getDimensionDescriptionNodes(org.w3c.dom.Element root)`
    `private org.w3c.dom.Element` | `getImageDescription(org.w3c.dom.Element root)`
    `private org.w3c.dom.Element` | `getMetadataRoot(java.lang.String xml)`
    `private org.w3c.dom.NodeList` | `getNodes(org.w3c.dom.Element root, java.lang.String nodeName)`
    `int` | `getOptimalTileHeight()` Returns the optimal sub-image height for use with openBytes.
    `java.lang.String[]` | `getSeriesUsedFiles(boolean noPixels)` Returns an array of filenames needed to open the current series.
    `private int` | `getTileIndex(int coreIndex)`
    `protected void` | `initFile(java.lang.String id)` Initializes the given file (parsing header information, etc.).
    `private void` | `initMetadata(java.lang.String xml)` Parses a string of XML and puts the values in a Hashtable.
    `boolean` | `isThisType(loci.common.RandomAccessInputStream stream)` Checks if the given stream is a valid stream for this file format.
    `byte[]` | `openBytes(int no, byte[] buf, int x, int y, int w, int h)` Obtains a sub-image of the specified image plane into a pre-allocated byte array.
    `private void` | `populateOriginalMetadata(org.w3c.dom.Element root, java.util.Deque<java.lang.String> nameStack, int[] key_index, int jj)`
    `private void` | `seekStartOfPlane(int no, long dataOffset, long planeSize)`
    `private void` | `translateAttachmentNodes(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateDetectors(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateFilterSettings(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateImageNames(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateImageNodes(org.w3c.dom.Element imageNode, int i)`
    `private void` | `translateLaserLines(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateMetadata(org.w3c.dom.Element root)`
    `private void` | `translateROIs(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateScannerSettings(org.w3c.dom.Element imageNode, int image)`
    `private void` | `translateSingleROIs(org.w3c.dom.Element imageNode, int image)`
    `private double` | `translateSingleTimestamp(org.w3c.dom.Element timestamp)`
    `private double` | `translateSingleTimestamp(java.lang.String timestamp)`
    `private void` | `translateTimestamps(org.w3c.dom.Element imageNode, int image)`
    `boolean` | `useOldPhysicalSizeCalculation()`

    - ### Methods inherited from class loci.formats.FormatReader

      `addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMetaList, addMeta, addMetaList, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMetaList, close, coreIndexToSeries, fileGroupOption, flattenHashtables, getAcquisitionMode, getAdvancedSeriesUsedFiles, getAdvancedUsedFiles, getArcType, getBinning, getBitsPerPixel, getCompression, getContrastMethod, getCoreIndex, getCoreMetadataList, getCorrection, getCurrentCore, getCurrentFile, getDatasetStructureDescription, getDetectorType, getDimensionOrder, getDimensionOrder, getDomains, getEffectiveSizeC, getExperimentType, getFilamentType, getFillColor, getFillRule, getFilterType, getFontFamily, getFontStyle, getGlobalMeta, getGlobalMetadata, getIlluminationType, getImageCount, getImmersion, getIndex, getIndex, getLaserMedium, getLaserType, getMarker, getMedium, getMetadataStore, getMetadataStoreRoot, getMetadataValue, getMicrobeamManipulationType, getMicroscopeType, getModuloC, getModuloT, getModuloZ, getNamingConvention, getOptimalTileWidth, getPixelType, getPixelType, getPossibleDomains, getPulse, getRequiredDirectories, getResolution, getResolutionCount, getRGBChannelCount, getRotationTransform, getSeries, getSeriesCount, getSeriesMeta, getSeriesMetadata, getSeriesMetadataValue, getSeriesUsedFiles, getSizeC, getSizeT, getSizeX, getSizeY, getSizeZ, getThumbSizeX, getThumbSizeY, getTileColumns, getTileRows, getUnderlyingReaders, getUsedFiles, getUsedFiles, getZCTCoords, getZCTModuloCoords, hasCompanionFiles, hasFlattenedResolutions, isFalseColor, isGroupFiles, isIndexed, isInterleaved, isInterleaved, isLittleEndian, isMetadataComplete, isMetadataFiltered, isNormalized, isOrderCertain, isOriginalMetadataPopulated, isRGB, isSingleFile, isThisType, isThisType, isThisType, isThumbnailSeries, isUsedFile, makeFilterMetadata, openBytes, openBytes, openBytes, openPlane, openThumbBytes, readPlane, readPlane, readPlane, reopenFile, seriesToCoreIndex, setCoreIndex, setFillColor, setFlattenedResolutions, setGroupFiles, setId, setMetadataFiltered, setMetadataStore, setNormalized, setOriginalMetadataPopulated, setResolution, setSeries, updateMetadataLists`

    - ### Methods inherited from class loci.formats.FormatHandler

      `checkSuffix, checkSuffix, getFormat, getMetadataOptions, getNativeDataType, getSuffixes, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface loci.formats.IFormatHandler

      `getFormat, getNativeDataType, getSuffixes`

    - ### Methods inherited from interface loci.formats.IMetadataConfigurable

      `getMetadataOptions, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from interface loci.formats.ICompressedTileReader

      `getTileCodec, getTileCodecOptions, openCompressedBytes, openCompressedBytes`

- - ### Field Detail

    - #### OLD_PHYSICAL_SIZE_KEY

          public static final java.lang.String OLD_PHYSICAL_SIZE_KEY

      See Also:
        Constant Field Values

    - #### OLD_PHYSICAL_SIZE_DEFAULT

          public static final boolean OLD_PHYSICAL_SIZE_DEFAULT

      See Also:
        Constant Field Values

    - #### LIF_MAGIC_BYTE

          public static final byte LIF_MAGIC_BYTE

      See Also:
        Constant Field Values

    - #### LIF_MEMORY_BYTE

          public static final byte LIF_MEMORY_BYTE

      See Also:
        Constant Field Values

    - #### ENCODING

          private static final java.lang.String ENCODING

      The encoding used in this file.
      See Also:
        Constant Field Values

    - #### LOGO_FILE

          private static final java.lang.String LOGO_FILE

      See Also:
        Constant Field Values

    - #### STYLESHEET_FILE

          private static final java.lang.String STYLESHEET_FILE

      See Also:
        Constant Field Values

    - #### CHANNEL_PRIORITIES

          private static final com.google.common.collect.ImmutableMap<java.lang.String,java.lang.Integer> CHANNEL_PRIORITIES

    - #### METER_MULTIPLY

          private static final long METER_MULTIPLY

      See Also:
        Constant Field Values

    - #### memoryBlocks

          private java.util.List<LIFReader.MemoryBlock> memoryBlocks

      Memory blocks including offsets and ID

    - #### realChannel

          private int[][] realChannel

    - #### lastChannel

          private int lastChannel

    - #### lutNames

          private java.util.List<java.lang.String> lutNames

    - #### physicalSizeXs

          private java.util.List<java.lang.Double> physicalSizeXs

    - #### physicalSizeYs

          private java.util.List<java.lang.Double> physicalSizeYs

    - #### fieldPosX

          private java.util.List<ome.units.quantity.Length> fieldPosX

    - #### fieldPosY

          private java.util.List<ome.units.quantity.Length> fieldPosY

    - #### descriptions

          private java.lang.String[] descriptions

    - #### microscopeModels

          private java.lang.String[] microscopeModels

    - #### serialNumber

          private java.lang.String[] serialNumber

    - #### pinholes

          private java.lang.Double[] pinholes

    - #### zooms

          private java.lang.Double[] zooms

    - #### zSteps

          private java.lang.Double[] zSteps

    - #### tSteps

          private java.lang.Double[] tSteps

    - #### lensNA

          private java.lang.Double[] lensNA

    - #### flipX

          private boolean[] flipX

    - #### flipY

          private boolean[] flipY

    - #### swapXY

          private boolean[] swapXY

    - #### expTimes

          private java.lang.Double[][] expTimes

    - #### gains

          private java.lang.Double[][] gains

    - #### detectorOffsets

          private java.lang.Double[][] detectorOffsets

    - #### channelNames

          private java.lang.String[][] channelNames

    - #### detectorModels

          private java.util.List[] detectorModels

    - #### exWaves

          private java.lang.Double[][] exWaves

    - #### activeDetector

          private java.util.List[] activeDetector

    - #### detectorIndexes

          private java.util.HashMap[] detectorIndexes

    - #### immersions

          private java.lang.String[] immersions

    - #### corrections

          private java.lang.String[] corrections

    - #### objectiveModels

          private java.lang.String[] objectiveModels

    - #### magnification

          private java.lang.Double[] magnification

    - #### posX

          private ome.units.quantity.Length[] posX

    - #### posY

          private ome.units.quantity.Length[] posY

    - #### posZ

          private ome.units.quantity.Length[] posZ

    - #### refractiveIndex

          private java.lang.Double[] refractiveIndex

    - #### cutIns

          private java.util.List[] cutIns

    - #### cutOuts

          private java.util.List[] cutOuts

    - #### filterModels

          private java.util.List[] filterModels

    - #### timestamps

          private java.lang.Double[][] timestamps

    - #### laserWavelength

          private java.util.List[] laserWavelength

    - #### laserIntensity

          private java.util.List[] laserIntensity

    - #### laserActive

          private java.util.List[] laserActive

    - #### laserFrap

          private java.util.List[] laserFrap

    - #### imageROIs

          private LIFReader.ROI[][] imageROIs

    - #### alternateCenter

          private boolean alternateCenter

    - #### imageNames

          private java.lang.String[] imageNames

    - #### acquiredDate

          private double[] acquiredDate

    - #### tileCount

          private int[] tileCount

    - #### tileBytesInc

          private long[] tileBytesInc

    - #### endPointer

          private long endPointer

  - ### Constructor Detail

    - #### LIFReader

          public LIFReader()

      Constructs a new Leica LIF reader.

  - ### Method Detail

    - #### createChannelPriorities

          private static com.google.common.collect.ImmutableMap<java.lang.String,java.lang.Integer> createChannelPriorities()

    - #### useOldPhysicalSizeCalculation

          public boolean useOldPhysicalSizeCalculation()

    - #### getOptimalTileHeight

          public int getOptimalTileHeight()

      Description copied from interface: `IFormatReader`
      Returns the optimal sub-image height for use with openBytes.
      Specified by:
        `getOptimalTileHeight` in interface `IFormatReader`
      Overrides:
        `getOptimalTileHeight` in class `FormatReader`

    - #### isThisType

          public boolean isThisType(loci.common.RandomAccessInputStream stream)
                             throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Checks if the given stream is a valid stream for this file format. The number of bytes read is format-dependent.
      Specified by:
        `isThisType` in interface `IFormatReader`
      Overrides:
        `isThisType` in class `FormatReader`
      Parameters:
        `stream` - A RandomAccessInputStream representing the file to check. The first byte in the stream is assumed to be the first byte in the file.
      Returns:
        true if the file represented by the stream can be read by this reader; false otherwise.
      Throws:
        `java.io.IOException`

    - #### get8BitLookupTable

          public byte[][] get8BitLookupTable()

      Description copied from interface: `IFormatReader`
      Gets the 8-bit color lookup table associated with the most recently opened image. If no image planes have been opened, or if `IFormatReader.isIndexed()` returns false, then this may return null. Also, if `IFormatReader.getPixelType()` returns anything other than `FormatTools.INT8` or `FormatTools.UINT8`, this method will return null.
      Specified by:
        `get8BitLookupTable` in interface `IFormatReader`
      Overrides:
        `get8BitLookupTable` in class `FormatReader`

    - #### get16BitLookupTable

          public short[][] get16BitLookupTable()

      Description copied from interface: `IFormatReader`
      Gets the 16-bit color lookup table associated with the most recently opened image. If no image planes have been opened, or if `IFormatReader.isIndexed()` returns false, then this may return null. Also, if `IFormatReader.getPixelType()` returns anything other than `FormatTools.INT16` or `FormatTools.UINT16`, this method will return null.
      Specified by:
        `get16BitLookupTable` in interface `IFormatReader`
      Overrides:
        `get16BitLookupTable` in class `FormatReader`

    - #### openBytes

          public byte[] openBytes(int no,
                                  byte[] buf,
                                  int x,
                                  int y,
                                  int w,
                                  int h)
                           throws FormatException,
                                  java.io.IOException

      Description copied from interface: `IFormatReader`
      Obtains a sub-image of the specified image plane into a pre-allocated byte array.
      Specified by:
        `openBytes` in interface `IFormatReader`
      Specified by:
        `openBytes` in class `FormatReader`
      Parameters:
        `no` - the plane index within the current series.
        `buf` - a pre-allocated buffer.
        `x` - X coordinate of the upper-left corner of the sub-image
        `y` - Y coordinate of the upper-left corner of the sub-image
        `w` - width of the sub-image
        `h` - height of the sub-image
      Returns:
        the pre-allocated buffer `buf` for convenience.
      Throws:
        `FormatException` - if there was a problem parsing the metadata of the file.
        `java.io.IOException` - if there was a problem reading the file.
      See Also:
        `IFormatReader.openBytes(int, byte[], int, int, int, int)`

    - #### seekStartOfPlane

          private void seekStartOfPlane(int no,
                                        long dataOffset,
                                        long planeSize)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getSeriesUsedFiles

          public java.lang.String[] getSeriesUsedFiles(boolean noPixels)

      Description copied from interface: `IFormatReader`
      Returns an array of filenames needed to open the current series. If the 'noPixels' flag is set, then only files that do not contain pixel data will be returned. The first element in the array is expected to be the path passed to `IFormatHandler.setId(String)`, if appropriate based upon 'noPixels'. The remaining elements are expected to be in a consistent order; if a directory listing is necessary to build the list then it should be sorted first.
      Specified by:
        `getSeriesUsedFiles` in interface `IFormatReader`
      Overrides:
        `getSeriesUsedFiles` in class `FormatReader`

    - #### close

          public void close(boolean fileOnly)
                     throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Closes the currently open file. If the flag is set, this is all that happens; if unset, it is equivalent to calling `Closeable.close()`.
      Specified by:
        `close` in interface `IFormatReader`
      Overrides:
        `close` in class `FormatReader`
      Throws:
        `java.io.IOException`

    - #### getAvailableOptions

          protected java.util.ArrayList<java.lang.String> getAvailableOptions()

      Description copied from class: `FormatReader`
      Returns the list of available metadata options.
      Overrides:
        `getAvailableOptions` in class `FormatReader`

    - #### initFile

          protected void initFile(java.lang.String id)
                           throws FormatException,
                                  java.io.IOException

      Description copied from class: `FormatReader`
      Initializes the given file (parsing header information, etc.). Most subclasses should override this method to perform initialization operations such as parsing metadata.
      Overrides:
        `initFile` in class `FormatReader`
      Throws:
        `FormatException` - if a parsing error occurs processing the file.
        `java.io.IOException` - if an I/O error occurs processing the file

    - #### initMetadata

          private void initMetadata(java.lang.String xml)
                             throws FormatException,
                                    java.io.IOException

      Parses a string of XML and puts the values in a Hashtable.
      Throws:
        `FormatException`
        `java.io.IOException`

    - #### checkFlip

          private ome.units.quantity.Length checkFlip(boolean flip,
                                                      ome.units.quantity.Length pos)

    - #### getMetadataRoot

          private org.w3c.dom.Element getMetadataRoot(java.lang.String xml)
                                               throws FormatException,
                                                      java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### translateMetadata

          private void translateMetadata(org.w3c.dom.Element root)
                                  throws FormatException

      Throws:
        `FormatException`

    - #### populateOriginalMetadata

          private void populateOriginalMetadata(org.w3c.dom.Element root,
                                                java.util.Deque<java.lang.String> nameStack,
                                                int[] key_index,
                                                int jj)

    - #### translateImageNames

          private void translateImageNames(org.w3c.dom.Element imageNode,
                                           int image)

    - #### translateDetectors

          private void translateDetectors(org.w3c.dom.Element imageNode,
                                          int image)
                                   throws FormatException

      Throws:
        `FormatException`

    - #### translateROIs

          private void translateROIs(org.w3c.dom.Element imageNode,
                                     int image)
                              throws FormatException

      Throws:
        `FormatException`

    - #### translateSingleROIs

          private void translateSingleROIs(org.w3c.dom.Element imageNode,
                                           int image)
                                    throws FormatException

      Throws:
        `FormatException`

    - #### translateLaserLines

          private void translateLaserLines(org.w3c.dom.Element imageNode,
                                           int image)
                                    throws FormatException

      Throws:
        `FormatException`

    - #### translateTimestamps

          private void translateTimestamps(org.w3c.dom.Element imageNode,
                                           int image)
                                    throws FormatException

      Throws:
        `FormatException`

    - #### translateSingleTimestamp

          private double translateSingleTimestamp(java.lang.String timestamp)

    - #### translateSingleTimestamp

          private double translateSingleTimestamp(org.w3c.dom.Element timestamp)

    - #### translateFilterSettings

          private void translateFilterSettings(org.w3c.dom.Element imageNode,
                                               int image)
                                        throws FormatException

      Throws:
        `FormatException`

    - #### translateScannerSettings

          private void translateScannerSettings(org.w3c.dom.Element imageNode,
                                                int image)
                                         throws FormatException

      Throws:
        `FormatException`

    - #### translateAttachmentNodes

          private void translateAttachmentNodes(org.w3c.dom.Element imageNode,
                                                int image)
                                         throws FormatException

      Throws:
        `FormatException`

    - #### addUserCommentMeta

          private void addUserCommentMeta(org.w3c.dom.Element imageNode,
                                          int image)
                                   throws FormatException

      Throws:
        `FormatException`

    - #### translateImageNodes

          private void translateImageNodes(org.w3c.dom.Element imageNode,
                                           int i)
                                    throws FormatException

      Throws:
        `FormatException`

    - #### getNodes

          private org.w3c.dom.NodeList getNodes(org.w3c.dom.Element root,
                                                java.lang.String nodeName)

    - #### getImageDescription

          private org.w3c.dom.Element getImageDescription(org.w3c.dom.Element root)

    - #### getChannelDescriptionNodes

          private org.w3c.dom.NodeList getChannelDescriptionNodes(org.w3c.dom.Element root)

    - #### getDimensionDescriptionNodes

          private org.w3c.dom.NodeList getDimensionDescriptionNodes(org.w3c.dom.Element root)

    - #### getChannelIndex

          private int getChannelIndex(org.w3c.dom.Element filterSetting)

    - #### getChannelColor

          private ome.xml.model.primitives.Color getChannelColor(int colorCode)

    - #### getTileIndex

          private int getTileIndex(int coreIndex)

Copyright © 2026 Open Microscopy Environment